#!/bin/bash

#pts listentries -users -cell {ics.muni.cz}[f:afsCell]                                                                 
#pts createuser -name {michalp@meta}[u:login@r:afsDefaultUsersRealm] -cell {ics.muni.cz}[f:afsCell]
#
#vos exa -id {home.michalp}[r:afsUsersVolume.u:login] -cell {ics.muni.cz}[f:afsCell]
#vos create -server {smaug1}[f:afsServer] -partition {a}[f:afsPartition] -name {home.michalp}[r:afsUsersVolume.u:login] -maxquota {50*1024}[u:f:afsUserQuota r:afsDefaultUserQuota] -cell {ics.muni.cz}[f:afsCell]
#
#test -e /afs/.{ics.muni.cz}[f:afsCell]/{home/michalp}[r:afsUsersMountPoint]/[u:login]
#fs lsmount -dir /afs/.{ics.muni.cz}[f:afsCell]/{home/michalp}[r:afsUsersMountPoint]/[u:login]
#fs mkmount -dir /afs/.{ics.muni.cz}/{home/michalp} -vol {home.michalp}[r:afsUsersVolume.u:login] -cell {ics.muni.cz}[f:afsCell]
#
#fs sa -dir /afs/.{ics.muni.cz}[f:afsCell]/{home/michalp}[r:afsUsersMountPoint]/[u:login] -acl {michalp@meta}[u:login@r:afsUsersRealm] all
#fs sa -dir /afs/.{ics.muni.cz}[f:afsCell]/{home/michalp}[r:afsUsersMountPoint]/[u:login] -acl roots rl
#
#fs sq -path /afs/.{ics.muni.cz}[f:afsCell]/{home/michalp}[r:afsUsersMountPoint]/[u:login] -max {50*1024}[u:f:afsUserQuota r:afsDefaultUserQuota]
#
#vos rel {home}[r:afsVolume] -cell {ics.muni.cz}[f:afsCell

# List of logins who have to have directory in the /home
PROTOCOL_VERSION='3.0.0'

function process {

  E_FINISHED_WITH_ERRORS=(50 'AFS slave script finished with errors')

  FROM_PERUN="${WORK_DIR}/afs"
  ERROR=0


  create_lock

  VOLUMES_TO_RELEASE="" # release at the end of the script.  SYNTAX: volume:cell\nvol2:cel2\n

  while IFS=`echo -e "\t"` read AFS_SERVER AFS_CELL AFS_PARTITION AFS_DEFAULT_USERS_REALM AFS_USERS_MOUNT_POINT AFS_USERS_VOLUME AFS_VOLUME USER_LOGIN USER_QUOTA; do

     pts listentries -users -cell "$AFS_CELL" | grep -q -F "$AFS_DEFAULT_USERS_REALM" 
     if [ $? -eq 0 ]; then
          pts createuser -name "$USER_LOGIN@$AFS_DEFAULT_USERS_REALM" -cell "$AFS_CELL"
          if [ $? -ne 0 ]; then
             echo "Command failed: pts createuser -name $AFS_DEFAULT_USERS_REALM -cell $AFS_CELL" >&2
             ERROR=1
          fi
     fi
  
    vos exa -id "$AFS_USERS_VOLUME.$USER_LOGIN" -cell "$AFS_CELL" || vos create -server "$AFS_SERVER" -partition "$AFS_PARTITION" -name "$AFS_USERS_VOLUME.$USER_LOGIN" -maxquota {50*1024}[u:f:afsUserQuota r:afsDefaultUserQuota] -cell "$AFS_CELL"
    [ $? -eq 0 ] || echo "Command failed: vos create -server $AFS_SERVER -partition $AFS_PARTITION -name $AFS_USERS_VOLUME.$USER_LOGIN -maxquota {50*1024}[u:f:afsUserQuota r:afsDefaultUserQuota] -cell $AFS_CELL" >&2
  
  
    if [ -e "/afs/.$AFS_CELL/$AFS_USERS_MOUNT_POINT/$USER_LOGIN" ]; then
         if fs lsmount -dir "/afs/.$AFS_CELL/$AFS_USERS_MOUNT_POINT/$USER_LOGIN" ; then 
             fs mkmount -dir "/afs/.$AFS_CELL/$AFS_USERS_MOUNT_POINT/$USER_LOGIN" -vol "$AFS_USERS_MOUNT_POINT.$USER_LOGIN" -cell "$AFS_CELL" 
             if [ $? -ne 0 ]; then
               echo "Command failed: fs mkmount -dir /afs/.$AFS_CELL/$AFS_USERS_MOUNT_POINT/$USER_LOGIN -vol $AFS_USERS_MOUNT_POINT.$USER_LOGIN -cell $AFS_CELL" >&2
               ERROR=1
             fi
         fi
     fi
  
  
     fs sq -path "/afs/.$AFS_CELL/$AFS_USERS_MOUNT_POINT/$USER_LOGIN" -max "$USER_QUOTA" 
     if [ $? -ne 0 ]; then 
       echo "Command failed: fs sq -path /afs/.$AFS_CELL/$AFS_USERS_MOUNT_POINT/$USER_LOGIN -max $USER_QUOTA" >&2
       ERROR=1
     fi
     
     #add volume:cell to VOLUMES_TO_RELEASE if it doesn't containt then yet
     echo $VOLUMES_TO_RELEASE | grep -q '\(^\|\\n\)'"$AFS_VOLUME:$AFS_CELL"'\($\|\\n\)' || VOLUMES_TO_RELEASE="$VOLUMES_TO_RELEASE$AFS_VOLUME:$AFS_CELL\\n"


    done < "${FROM_PERUN}"

    echo -e -n "$VOLUMES_TO_RELEASE" | while IFS=":" read VOL CELL ; do
        vos rel "$VOL" -cell "$CELL" 
        if [ $? -ne 0 ]; then 
          echo "Command failed: vos rel $VOL -cell $CELL" >&2
          ERROR=1
        fi
    done 

    [ $ERROR -eq 0 ] || log_msg E_FINISHED_WITH_ERRORS
}
