#!/bin/bash

PROTOCOL_VERSION='3.0.0'

E_PASSWD_FILTER=(50 'Default realm is not defined')

function process {
	default_realm=`grep "^  *default_realm" /etc/krb5.conf | awk -F= '{print $2}' | sed -e "s/ //g"`

	[ -z "$default_realm" ] && exit 1

	for f in $files; do
        realm=`head -n1 $f`
        suffix=`echo $f | awk -F- '{print $2}'`
        KDC_DIR=$DEST/heimdal.$suffix
        if [ "$realm" = "$default_realm" ]; then
                KDC_DIR=$DEST/heimdal
        fi

        [ -f $KDC_DIR/pki-mapping -a -f $KDC_DIR/pki-mapping.base ] || continue

        rm -f $KDC_DIR/pki-mapping.new

        cp $KDC_DIR/pki-mapping.base $KDC_DIR/pki-mapping.new
        tail +2 $f >> $KDC_DIR/pki-mapping.new

        chmod 0644 $KDC_DIR/pki-mapping.new
        rm -f $KDC_DIR/pki-mapping.old
        ln $KDC_DIR/pki-mapping $KDC_DIR/pki-mapping.old
        ln -f $KDC_DIR/pki-mapping.new $KDC_DIR/pki-mapping
	done

	cd $VAR_RUN
	for i in kdc.*.pid; do
        kill -HUP `cat $i`
	done
}
